org.richfaces.renderkit

## Class AbstractTableRenderer

- java.lang.Object
- - javax.faces.render.Renderer
  - - org.richfaces.renderkit.RendererBase
    - - org.richfaces.renderkit.AbstractRowsRenderer
      - - org.richfaces.renderkit.SortingFilteringRowsRenderer
        - - org.richfaces.renderkit.AbstractTableBaseRenderer
          - - org.richfaces.renderkit.AbstractTableRenderer

- All Implemented Interfaces:
    DataVisitor, MetaComponentRenderer
  Direct Known Subclasses:
    CollapsibleSubTableRenderer, DataTableRenderer

      public abstract class AbstractTableRenderer
      extends AbstractTableBaseRenderer
      implements MetaComponentRenderer

  Author:
    Anton Belevich

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `AbstractTableRenderer.SimpleHeaderEncodeStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `HIDDEN_CONTAINER_ID`

    - ### Fields inherited from class org.richfaces.renderkit.AbstractTableBaseRenderer

      `BREAK_ROW_BEFORE, CELL_CLASS_KEY, COLUMN_CLASS, FIRST_ROW_CLASS_KEY, ROW_CLASS, ROW_CLASS_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractTableRenderer()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract boolean` | `containsThead()`
    `RowHolderBase` | `createRowHolder(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, Object[] options)`
    `void` | `decodeMetaComponent(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, String metaComponentId)`
    `protected void` | `doDecode(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component)` Template method for custom decoding of concrete renderer.
    `protected void` | `doEncodeChildren(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext context, javax.faces.component.UIComponent component)`
    `void` | `encodeAfterRows(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext facesContext, UIDataTableBase dataTableBase, boolean encodeParentTBody, boolean partialUpdate)`
    `void` | `encodeBeforeRows(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext facesContext, UIDataTableBase dataTableBase, boolean encodeParentTBody, boolean partialUpdate)`
    `abstract void` | `encodeClientScript(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext context, UIDataTableBase component)`
    `protected void` | `encodeColumnFacet(javax.faces.context.FacesContext context, javax.faces.context.ResponseWriter writer, UIDataTableBase dataTableBase, String facetName, int colCount, String cellClass)`
    `void` | `encodeFooterFacet(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext facesContext, UIDataTableBase dataTable, boolean encodePartialUpdate)`
    `void` | `encodeHeaderFacet(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext facesContext, UIDataTableBase dataTable, boolean encodePartialUpdate)`
    `abstract void` | `encodeHiddenInput(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext context, UIDataTableBase component)`
    `protected void` | `encodeHiddens(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext facesContext, UIDataTableBase dataTableBase, Object[] params)`
    `void` | `encodeMetaComponent(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, String metaComponentId)`
    `void` | `encodeNoDataFacetOrLabel(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext facesContext, UIDataTableBase dataTableBase)`
    `abstract boolean` | `encodeParentTBody(UIDataTableBase dataTableBase)`
    `void` | `encodeTableBodyEnd(javax.faces.context.ResponseWriter writer)`
    `void` | `encodeTableBodyStart(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext facesContext, UIDataTableBase dataTableBase)`
    `void` | `encodeTableEnd(javax.faces.context.ResponseWriter writer)`
    `protected void` | `encodeTableFacet(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, String id, int columns, javax.faces.component.UIComponent footer, String facetName, String rowClass, String cellClass, boolean encodePartialUpdate)`
    `void` | `encodeTableFacets(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext context, UIDataTableBase dataTable)`
    `void` | `encodeTableRows(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext facesContext, UIDataTableBase dataTableBase, boolean encodePartialUpdate)`
    `void` | `encodeTableStart(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext context, UIDataTableBase component)`
    `void` | `encodeTableStructure(javax.faces.context.ResponseWriter writer, javax.faces.context.FacesContext context, UIDataTableBase dataTable)`
    `abstract String` | `getCellSkinClass()`
    `abstract String` | `getColumnFooterCellSkinClass()`
    `abstract String` | `getColumnFooterFirstSkinClass()`
    `abstract String` | `getColumnFooterSkinClass()`
    `abstract String` | `getColumnHeaderCellSkinClass()`
    `abstract String` | `getColumnHeaderFirstSkinClass()`
    `abstract String` | `getColumnHeaderSkinClass()`
    `abstract String` | `getFirstRowSkinClass()`
    `abstract String` | `getFooterCellSkinClass()`
    `abstract String` | `getFooterFirstSkinClass()`
    `abstract String` | `getFooterSkinClass()`
    `abstract String` | `getHeaderCellSkinClass()`
    `abstract EncodeStrategy` | `getHeaderEncodeStrategy(javax.faces.component.UIComponent column, String tableFacetName)`
    `abstract String` | `getHeaderFirstSkinClass()`
    `abstract String` | `getHeaderSkinClass()`
    `abstract EncodeStrategy` | `getHiddenContainerStrategy(UIDataTableBase dataTableBase)`
    `abstract String` | `getNoDataCellClass()`
    `abstract String` | `getNoDataClass()`
    `abstract String` | `getRowSkinClass()`
    `abstract String` | `getTableBodySkinClass()`
    `abstract String` | `getTableSkinClass()`
    `boolean` | `isColumnAttributeSet(UIDataTableBase table, String attributeName)`
    `protected boolean` | `isEncodeHeaders(UIDataTableBase table)`
    `protected String` | `mergeStyleClasses(String classAttribibute, String skinClass, javax.faces.component.UIComponent component)`
    `protected void` | `partialEnd(javax.faces.context.FacesContext facesContext)`
    `protected void` | `partialStart(javax.faces.context.FacesContext facesContext, String id)`
    `protected void` | `preEncodeBegin(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component)` Clear the extendedDataModel before the component encode begins.
    `protected void` | `putRowStylesIntoContext(javax.faces.context.FacesContext facesContext, RowHolderBase rowHolder)`

    - ### Methods inherited from class org.richfaces.renderkit.AbstractTableBaseRenderer

      `encodeColumn, encodeColumnEnd, encodeColumnStart, encodeFakeRow, encodeFirstRowEnd, encodeFirstRowStart, encodeRowEnd, encodeRowStart, encodeStyle, encodeStyleClass, getCellClass, getCellElement, getColumnsCount, getFirstRowClass, getRowClass, isEmpty, isEmptyAttr, saveRowStyles, setCellElement`

    - ### Methods inherited from class org.richfaces.renderkit.SortingFilteringRowsRenderer

      `decodeFiltering, decodeSorting, decodeSortingFiltering, isBuiltInSortRequiredFocColumn, isFilterRowRequiredForColumn, renderFilterRow, renderSortButton, updateAttribute`

    - ### Methods inherited from class org.richfaces.renderkit.AbstractRowsRenderer

      `doCleanup, encodeRow, encodeRows, get, getColumnClass, getColumnClasses, getRendersChildren, getRowClass, getRowClassAttribute, getRowClasses, process, processRows, put, renderRowHandlers`

    - ### Methods inherited from class org.richfaces.renderkit.RendererBase

      `concatClasses, concatStyles, decode, doEncodeBegin, doEncodeEnd, encodeBegin, encodeChildren, encodeEnd, getComponentClass, getResourcePath, getSkin, getUtils, isAlreadyRendered, preDecode, queueComponentEventForBehaviorEvent, renderChildren`

    - ### Methods inherited from class javax.faces.render.Renderer

      `convertClientId, getConvertedValue`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### HIDDEN_CONTAINER_ID

          public static final String HIDDEN_CONTAINER_ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AbstractTableRenderer

          public AbstractTableRenderer()

  - ### Method Detail

    - #### getHiddenContainerStrategy

          public abstract EncodeStrategy getHiddenContainerStrategy(UIDataTableBase dataTableBase)

    - #### isColumnAttributeSet

          public boolean isColumnAttributeSet(UIDataTableBase table,
                                              String attributeName)

    - #### createRowHolder

          public RowHolderBase createRowHolder(javax.faces.context.FacesContext context,
                                               javax.faces.component.UIComponent component,
                                               Object[] options)

      Specified by:
        `createRowHolder` in class `AbstractRowsRenderer`

    - #### doDecode

          protected void doDecode(javax.faces.context.FacesContext context,
                                  javax.faces.component.UIComponent component)

      Description copied from class: `RendererBase`
      Template method for custom decoding of concrete renderer. All parameters checking if performed in original `RendererBase.decode(FacesContext, UIComponent)` method.
      Overrides:
        `doDecode` in class `RendererBase`

    - #### putRowStylesIntoContext

          protected void putRowStylesIntoContext(javax.faces.context.FacesContext facesContext,
                                                 RowHolderBase rowHolder)

    - #### isEncodeHeaders

          protected boolean isEncodeHeaders(UIDataTableBase table)

    - #### encodeTableStructure

          public void encodeTableStructure(javax.faces.context.ResponseWriter writer,
                                           javax.faces.context.FacesContext context,
                                           UIDataTableBase dataTable)
                                    throws IOException

      Throws:
        `IOException`

    - #### encodeBeforeRows

          public void encodeBeforeRows(javax.faces.context.ResponseWriter writer,
                                       javax.faces.context.FacesContext facesContext,
                                       UIDataTableBase dataTableBase,
                                       boolean encodeParentTBody,
                                       boolean partialUpdate)
                                throws IOException

      Throws:
        `IOException`

    - #### encodeAfterRows

          public void encodeAfterRows(javax.faces.context.ResponseWriter writer,
                                      javax.faces.context.FacesContext facesContext,
                                      UIDataTableBase dataTableBase,
                                      boolean encodeParentTBody,
                                      boolean partialUpdate)
                               throws IOException

      Throws:
        `IOException`

    - #### encodeParentTBody

          public abstract boolean encodeParentTBody(UIDataTableBase dataTableBase)

    - #### encodeTableFacets

          public void encodeTableFacets(javax.faces.context.ResponseWriter writer,
                                        javax.faces.context.FacesContext context,
                                        UIDataTableBase dataTable)
                                 throws IOException

      Throws:
        `IOException`

    - #### encodeTableRows

          public void encodeTableRows(javax.faces.context.ResponseWriter writer,
                                      javax.faces.context.FacesContext facesContext,
                                      UIDataTableBase dataTableBase,
                                      boolean encodePartialUpdate)
                               throws IOException

      Throws:
        `IOException`

    - #### encodeNoDataFacetOrLabel

          public void encodeNoDataFacetOrLabel(javax.faces.context.ResponseWriter writer,
                                               javax.faces.context.FacesContext facesContext,
                                               UIDataTableBase dataTableBase)
                                        throws IOException

      Throws:
        `IOException`

    - #### preEncodeBegin

          protected void preEncodeBegin(javax.faces.context.FacesContext context,
                                        javax.faces.component.UIComponent component)
                                 throws IOException

      Clear the extendedDataModel before the component encode begins. This is to force the extendedDataModel to be re-initialized taking into account any model changes that were applied since the model was created in the RESTORE_VIEW phase.
      Overrides:
        `preEncodeBegin` in class `RendererBase`
      Parameters:
        `context` -
        `component` -
      Throws:
        `IOException`

    - #### doEncodeChildren

          protected void doEncodeChildren(javax.faces.context.ResponseWriter writer,
                                          javax.faces.context.FacesContext context,
                                          javax.faces.component.UIComponent component)
                                   throws IOException

      Overrides:
        `doEncodeChildren` in class `AbstractRowsRenderer`
      Throws:
        `IOException`

    - #### encodeTableStart

          public void encodeTableStart(javax.faces.context.ResponseWriter writer,
                                       javax.faces.context.FacesContext context,
                                       UIDataTableBase component)
                                throws IOException

      Throws:
        `IOException`

    - #### encodeHiddens

          protected void encodeHiddens(javax.faces.context.ResponseWriter writer,
                                       javax.faces.context.FacesContext facesContext,
                                       UIDataTableBase dataTableBase,
                                       Object[] params)
                                throws IOException

      Throws:
        `IOException`

    - #### encodeTableEnd

          public void encodeTableEnd(javax.faces.context.ResponseWriter writer)
                              throws IOException

      Throws:
        `IOException`

    - #### encodeClientScript

          public abstract void encodeClientScript(javax.faces.context.ResponseWriter writer,
                                                  javax.faces.context.FacesContext context,
                                                  UIDataTableBase component)
                                           throws IOException

      Throws:
        `IOException`

    - #### encodeHiddenInput

          public abstract void encodeHiddenInput(javax.faces.context.ResponseWriter writer,
                                                 javax.faces.context.FacesContext context,
                                                 UIDataTableBase component)
                                          throws IOException

      Throws:
        `IOException`

    - #### encodeTableBodyStart

          public void encodeTableBodyStart(javax.faces.context.ResponseWriter writer,
                                           javax.faces.context.FacesContext facesContext,
                                           UIDataTableBase dataTableBase)
                                    throws IOException

      Throws:
        `IOException`

    - #### encodeTableBodyEnd

          public void encodeTableBodyEnd(javax.faces.context.ResponseWriter writer)
                                  throws IOException

      Throws:
        `IOException`

    - #### encodeFooterFacet

          public void encodeFooterFacet(javax.faces.context.ResponseWriter writer,
                                        javax.faces.context.FacesContext facesContext,
                                        UIDataTableBase dataTable,
                                        boolean encodePartialUpdate)
                                 throws IOException

      Throws:
        `IOException`

    - #### mergeStyleClasses

          protected String mergeStyleClasses(String classAttribibute,
                                             String skinClass,
                                             javax.faces.component.UIComponent component)

    - #### encodeHeaderFacet

          public void encodeHeaderFacet(javax.faces.context.ResponseWriter writer,
                                        javax.faces.context.FacesContext facesContext,
                                        UIDataTableBase dataTable,
                                        boolean encodePartialUpdate)
                                 throws IOException

      Throws:
        `IOException`

    - #### encodeColumnFacet

          protected void encodeColumnFacet(javax.faces.context.FacesContext context,
                                           javax.faces.context.ResponseWriter writer,
                                           UIDataTableBase dataTableBase,
                                           String facetName,
                                           int colCount,
                                           String cellClass)
                                    throws IOException

      Throws:
        `IOException`

    - #### encodeTableFacet

          protected void encodeTableFacet(javax.faces.context.FacesContext facesContext,
                                          javax.faces.context.ResponseWriter writer,
                                          String id,
                                          int columns,
                                          javax.faces.component.UIComponent footer,
                                          String facetName,
                                          String rowClass,
                                          String cellClass,
                                          boolean encodePartialUpdate)
                                   throws IOException

      Throws:
        `IOException`

    - #### getHeaderEncodeStrategy

          public abstract EncodeStrategy getHeaderEncodeStrategy(javax.faces.component.UIComponent column,
                                                                 String tableFacetName)

    - #### containsThead

          public abstract boolean containsThead()

    - #### getTableSkinClass

          public abstract String getTableSkinClass()

    - #### getTableBodySkinClass

          public abstract String getTableBodySkinClass()

    - #### getFirstRowSkinClass

          public abstract String getFirstRowSkinClass()

    - #### getRowSkinClass

          public abstract String getRowSkinClass()

    - #### getHeaderCellSkinClass

          public abstract String getHeaderCellSkinClass()

    - #### getHeaderSkinClass

          public abstract String getHeaderSkinClass()

    - #### getHeaderFirstSkinClass

          public abstract String getHeaderFirstSkinClass()

    - #### getColumnHeaderCellSkinClass

          public abstract String getColumnHeaderCellSkinClass()

    - #### getColumnHeaderSkinClass

          public abstract String getColumnHeaderSkinClass()

    - #### getColumnHeaderFirstSkinClass

          public abstract String getColumnHeaderFirstSkinClass()

    - #### getFooterCellSkinClass

          public abstract String getFooterCellSkinClass()

    - #### getFooterSkinClass

          public abstract String getFooterSkinClass()

    - #### getFooterFirstSkinClass

          public abstract String getFooterFirstSkinClass()

    - #### getColumnFooterCellSkinClass

          public abstract String getColumnFooterCellSkinClass()

    - #### getColumnFooterSkinClass

          public abstract String getColumnFooterSkinClass()

    - #### getColumnFooterFirstSkinClass

          public abstract String getColumnFooterFirstSkinClass()

    - #### getCellSkinClass

          public abstract String getCellSkinClass()

    - #### getNoDataClass

          public abstract String getNoDataClass()

    - #### getNoDataCellClass

          public abstract String getNoDataCellClass()

    - #### encodeMetaComponent

          public void encodeMetaComponent(javax.faces.context.FacesContext context,
                                          javax.faces.component.UIComponent component,
                                          String metaComponentId)
                                   throws IOException

      Specified by:
        `encodeMetaComponent` in interface `MetaComponentRenderer`
      Throws:
        `IOException`

    - #### decodeMetaComponent

          public void decodeMetaComponent(javax.faces.context.FacesContext context,
                                          javax.faces.component.UIComponent component,
                                          String metaComponentId)

      Specified by:
        `decodeMetaComponent` in interface `MetaComponentRenderer`

    - #### partialStart

          protected void partialStart(javax.faces.context.FacesContext facesContext,
                                      String id)
                               throws IOException

      Throws:
        `IOException`

    - #### partialEnd

          protected void partialEnd(javax.faces.context.FacesContext facesContext)
                             throws IOException

      Throws:
        `IOException`

Copyright © 2015 JBoss by Red Hat. All Rights Reserved.